##------------ Plot DFT Peaks vs # Samples -----------
## number of samples
## N = 8;

## sample_rate = 9600;

## frequencies = linspace(0,9600,100);
## phases = 0;

## X = [];
## for N = 4:16
## ## signals to be processed
## n = 0:N-1;
## X = [X;arrayfun(@(frequency) compute(cos(2*pi*frequency*n/sample_rate),N,1), frequencies)];
## endfor
## subplot(2,1,1)
## surf(frequencies,4:16,X)

##------------- What does it mean to take DFT at k = p/q? -------------
## subplot(2,1,2)
## hold on
## X = arrayfun(@(frequency) compute(cos(2*pi*frequency*n/sample_rate),N,1), frequencies);
## plot(frequencies,X,'r')
## X = arrayfun(@(frequency) compute(cos(2*pi*frequency*n/sample_rate),N,2), frequencies);
## plot(frequencies,X,'r')
## X = arrayfun(@(frequency) compute(cos(2*pi*frequency*n/sample_rate),N,1.5), frequencies);
## plot(frequencies,X,'g')
## X = arrayfun(@(frequency) compute(cos(2*pi*frequency*n/sample_rate),N,2.5), frequencies);
## plot(frequencies,X,'g')

##------------- Create coefficients for implementation in C ------------
N = 8

## generate DFT coefficients
Xd1 = e.^(-i*2*pi*(1200/9600)*[0:N-1]);
Xd2 = e.^(-i*2*pi*(2200/9600)*[0:N-1]);

## scale down coefficients by 1 bit since `1` can't be expressed as binary fraction
## e.g. `Xd1 = Xd1 * 127/128` for N = 8
Xd1 = Xd1*((2^(N-1) - 1)/2^(N-1));
Xd2 = Xd2*((2^(N-1) - 1)/2^(N-1));

## express coefficients as signed N-bit binary fractions
arrayfun(@(x) dec2binfrac(x,8),real(Xd1))
arrayfun(@(x) dec2binfrac(x,8),imag(Xd1))
arrayfun(@(x) dec2binfrac(x,8),real(Xd2))
arrayfun(@(x) dec2binfrac(x,8),imag(Xd2))




## surf(frequencies,X)
## zlabel('int value')
## ylabel('frequency')
## view(-90,180)
## print -dpng "-S1200,300" freq_phase.png
